#!/usr/bin/python
# IBM WebSphere eXtreme Scale Pattern
# 
# Copyright IBM Corp. 2017
# All rights reserved.
# US Government Users Restricted Rights -
# Use, duplication or disclosure restricted
# by GSA ADP Schedule Contract with IBM Corp.
# 
# Licensed Materials-Property of IBM
#

import sys
import urllib2
import xsldUtils
import json
import logging
import time
import optparse

parser = optparse.OptionParser()
parser.add_option("--description")
parser.add_option("--group_membership")
(options, args) = parser.parse_args()

logging.basicConfig()
logger = logging.getLogger("xsld/creategroup.py")
logger.debug('WebSphere eXtreme Scale Liberty Deployment create group script.')

xsadminPwd = sys.argv[1]
groupName = sys.argv[2]
role = sys.argv[3]
owner = sys.argv[4]
description = options.description
membership = options.group_membership

hostname='localhost'

s = "xsadmin:" + xsadminPwd
auth = "Basic " + s.encode("base64").rstrip()

url = 'https://%s:9445/wxsadmin/v1/group' % (hostname)
data = '{ \
"name": "%s", \
"description": "%s", \
"ownerName": "%s", \
"roleName": "%s" \
}' % (groupName,description,owner,role)

clen = len(data)
headers = {'Authorization': auth, 'Content-type': 'application/json', 'Accept': 'application/json', 'Content-Length': clen}

req = urllib2.Request(url, headers=headers, data=data)
f = urllib2.urlopen(req)
response = f.read()
f.close()

logger.debug(response)

if membership is None or membership == "":
   quit()
users = membership.split( )
if len(users) == 0:
   quit()

# Replace space with %20 for URL
groupURL = groupName.replace(" ", "%20")

headers = {'Authorization': auth, 'Content-type': 'application/json', 'Accept': 'application/json'}
for user in users:
   logger.debug('Adding %s to %s' % (user, groupName))
   url = 'https://%s:9445/wxsadmin/v1/users/%s/group/%s' % (hostname,user,groupURL)
   req = urllib2.Request(url, headers=headers)
   req.get_method = lambda: "POST"
   response = xsldUtils.openURL(req,logger)
   if response is None:
      logger.debug('Failed to get response from URL %s' % (url))
      sys.exit(1)
   
   logger.debug(response)

   
