#!/usr/bin/python
# IBM WebSphere eXtreme Scale Pattern
# 
# Copyright IBM Corp. 2017
# All rights reserved.
# US Government Users Restricted Rights -
# Use, duplication or disclosure restricted
# by GSA ADP Schedule Contract with IBM Corp.
# 
# Licensed Materials-Property of IBM
#

import sys
import urllib2
import xsldUtils
import json
import logging
import time
import optparse

parser = optparse.OptionParser()
parser.add_option("--email")
parser.add_option("--group")
parser.add_option("--name")
(options, args) = parser.parse_args()

logging.basicConfig()
logger = logging.getLogger("xsld/createuser.py")
logger.debug('WebSphere eXtreme Scale Liberty Deployment create user script.')

xsadminPwd = sys.argv[1]
username = sys.argv[2]
password = sys.argv[3]
email = options.email
name = options.name
group = options.group
isLdapUser = 'false'

hostname='localhost'

s = "xsadmin:" + xsadminPwd
auth = "Basic " + s.encode("base64").rstrip()

url = 'https://%s:9445/wxsadmin/v1/users' % (hostname)
data = '{ \
  "username": "%s", \
  "email": "%s", \
  "name": "%s", \
  "password": "%s", \
  "isLdapUser": %s \
}' % (username,email,name,password,isLdapUser)

clen = len(data)
headers = {'Authorization': auth, 'Content-type': 'application/json', 'Accept': 'application/json', 'Content-Length': clen}

req = urllib2.Request(url, headers=headers, data=data)
f = urllib2.urlopen(req)
response = f.read()
f.close()

logger.debug(response)

if group is None or group == "":
   quit()

# Replace space with %20 for URL
group = group.replace(" ", "%20")

# Add the user to a group if a group was specified
url = 'https://%s:9445/wxsadmin/v1/users/%s/group/%s' % (hostname,username,group)
headers = {'Authorization': auth, 'Content-type': 'application/json', 'Accept': 'application/json'}
req = urllib2.Request(url, headers=headers)
req.get_method = lambda: "POST"
response = xsldUtils.openURL(req,logger)
if response is None:
   logger.debug('Failed to get response from URL %s' % (url))
   sys.exit(1)

logger.debug(response)

