#!/usr/bin/python
# IBM WebSphere eXtreme Scale Pattern
# 
# Copyright IBM Corp. 2017
# All rights reserved.
# US Government Users Restricted Rights -
# Use, duplication or disclosure restricted
# by GSA ADP Schedule Contract with IBM Corp.
# 
# Licensed Materials-Property of IBM
#

import sys
import time
import urllib2
import json

def joinMember(logger,xsadminPwd,secretKey,memberName,cacheMemberGroupHost):
   hostname='localhost'
   
   s = "xsadmin:" + xsadminPwd
   auth = "Basic " + s.encode("base64").rstrip()
   
   url = 'https://%s:9445/wxsadmin/v1/task' % (hostname)
   data = '{ \
   "command": "NewMemberJoinTaskCommand", \
   "description": "Add a new member", \
   "parameters": {"secretKey": "%s", \
   "memberName": "%s", \
   "cacheMemberGroupHost": "%s", \
   "isCatalog": "true"} \
   }' % (secretKey,memberName,cacheMemberGroupHost)
   
   clen = len(data)
   headers = {'Authorization': auth, 'Content-type': 'application/json', 'Accept': 'application/json', 'Content-Length': clen}
   req = urllib2.Request(url, headers=headers, data=data)
   req.get_method = lambda: "POST"
   
   response = openURL(req,logger)
   if response is None:
      logger.debug('Failed to get response from URL %s' % (url))
      return None
   
   jsonData = json.loads(response)
   waitForTask(hostname, xsadminPwd, jsonData['taskid'])

def openURL(req,logger):
   response = None
   try:
      f = urllib2.urlopen(req)
      response = f.read()
      f.close()
   except urllib2.HTTPError, e:
      logger.error('HTTPError = ' + str(e.code) + ' ' + e.reason)
   except urllib2.URLError, e:
      logger.error('URLError = ' + str(e.reason))
   except httplib.HTTPException, e:
      logger.error('HTTPException')
   except Exception:
      logger.error('Exception opening URL ' + str(e.reason))
   
   return response

def waitForTask(memberHostname, xsadminPwd, taskID):
   s = "xsadmin:" + xsadminPwd
   auth = "Basic " + s.encode("base64").rstrip()

   url = 'https://%s:9445/wxsadmin/v1/task/%s/status' % (memberHostname, taskID)
   headers = {'Authorization': auth, 'Content-type': 'application/json', 'Accept': 'application/json'}
   req = urllib2.Request(url, headers=headers)
   f = urllib2.urlopen(req)
   response = f.read()
   f.close()
   
   jsonData = json.loads(response)
   while (jsonData['status'] != 'Success' and not 'error' in response and jsonData['status'] != 'Failed'):
      req = urllib2.Request(url, headers=headers)
      f = urllib2.urlopen(req)
      response = f.read()
      f.close()
      jsonData = json.loads(response)
      print "Response: " + response
      time.sleep(10)
   
   if ('error' in response or jsonData['status'] == 'Failed'):
      print 'Task %s failed' % taskID
